package com.liang.service.impl;

import com.liang.entity.SysDeptInfo;
import com.liang.dao.SysDeptInfoDao;
import com.liang.service.SysDeptInfoService;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 * (SysDeptInfo)表服务实现类
 *
 * @author makejava
 * @since 2023-03-10 18:09:43
 */
@Service("sysDeptInfoService")
public class SysDeptInfoServiceImpl implements SysDeptInfoService {
    @Resource
    private SysDeptInfoDao sysDeptInfoDao;

    /**
     * 通过ID查询单条数据
     *
     * @param deptId 主键
     * @return 实例对象
     */
    @Override
    public SysDeptInfo queryById(Integer deptId) {
        return this.sysDeptInfoDao.queryById(deptId);
    }

    /**
     * 分页查询
     *
     * @param sysDeptInfo 筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    @Override
    public Page<SysDeptInfo> queryByPage(SysDeptInfo sysDeptInfo, PageRequest pageRequest) {
        long total = this.sysDeptInfoDao.count(sysDeptInfo);
        return new PageImpl<>(this.sysDeptInfoDao.queryAllByLimit(sysDeptInfo, pageRequest), pageRequest, total);
    }

    /**
     * 新增数据
     *
     * @param sysDeptInfo 实例对象
     * @return 实例对象
     */
    @Override
    public int insert(SysDeptInfo sysDeptInfo) {
        return this.sysDeptInfoDao.insert(sysDeptInfo);
    }

    /**
     * 修改数据
     *
     * @param sysDeptInfo 实例对象
     * @return 实例对象
     */
    @Override
    public int update(SysDeptInfo sysDeptInfo) {
        return this.sysDeptInfoDao.update(sysDeptInfo);
    }

    /**
     * 通过主键删除数据
     *
     * @param deptId 主键
     * @return 是否成功
     */
    @Override
    public boolean deleteById(Integer deptId) {
        return this.sysDeptInfoDao.deleteById(deptId) > 0;
    }

    @Override
    public List<SysDeptInfo> list() {
        return this.sysDeptInfoDao.list();
    }

    @Override
    public List<SysDeptInfo> queryAll() {
        return this.sysDeptInfoDao.queryAll();
    }

    @Override
    public int batchDelete(List<Integer> deptIdList) {
        return this.sysDeptInfoDao.batchDelete(deptIdList);
    }

    @Override
    public String getUserDept(Integer sqr) {
        return sysDeptInfoDao.getUserDept(sqr);
    }

    @Override
    public List<SysDeptInfo> getDeptName() {
        List<SysDeptInfo> list = new ArrayList<>();
        if (this.sysDeptInfoDao.getDeptName().size() == 0){
            return list;
        }
        return this.sysDeptInfoDao.getDeptName();
    }
}
